#pragma once

enum TYPES {
	J_UNKNOWN=0x0,J_NULL=0x2,J_CODE,J_INTEGER,J_REAL,J_STRING,J_HANDLE,J_BOOLEAN,
	J_INTARRAY=0x9,J_REALARRAY,J_STRARRAY,J_HARRAY,J_BOOLARRAY
};

/*
char *TYPENAME[] = {
	"unknown","","null","code","integer","real","string","handle","boolean"
};
*/

enum OPCODES { OP_FUNCTION=0x3,OP_ENDFUNCTION=0x4,
	OP_LOCAL=0x5,OP_GLOBAL=0x6,OP_CONSTANT=0x7,OP_POPFUNCARG=0x8,OP_LITERAL=0xC,OP_SETRET=0xD,
	OP_GETVAR=0xE,OP_CODE=0xF,OP_GETARRAY=0x10,OP_SETVAR=0x11,OP_SETARRAY=0x12,OP_PUSH=0x13,OP_SETRIGHT=0x14,OP_NATIVE=0x15,
	OP_JASSCALL=0x16,
	OP_GREATEREQUAL=0x1D,OP_ADD=0x20,OP_SUB,OP_MUL,OP_DIV,
	OP_RETURN=0x27,
	OP_JUMPTARGET=0x28,OP_JUMPIFTRUE=0x29,OP_JUMP=0x2B };

typedef struct {
	unsigned char r1;
	unsigned char r2;
	unsigned char r3;
	unsigned char optype;
	int arg;
} opcode;

