#pragma once

#define REGISTERNATIVESOFFSET 5
unsigned char RegisterNativesPattern[] =
{
	0x90,0x90,0x90,0x90,0x90,
	0xE8,0x00,0x00,0x00,0x00,
	0x68,0x00,0x00,0x00,0x00,
	0xBA,0x00,0x00,0x00,0x00,
	0xB9,0x00,0x00,0x00,0x00,
	0xE8,0x00,0x00,0x00,0x00
};

unsigned char RegisterNativesMask[] =
{
	0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0x00,0x00,0x00,0x00,
	0xFF,0x00,0x00,0x00,0x00,
	0xFF,0x00,0x00,0x00,0x00,
	0xFF,0x00,0x00,0x00,0x00,
	0xFF,0x00,0x00,0x00,0x00,
};

unsigned char NativeRegPattern[] =
{
	0xBA,0x00,0x00,0x00,0x00,	// nativename address inserted here
	0xB9,0x00,0x00,0x00,0x00,	// war3_native address altered here
	0xE8,0x00,0x00,0x00,0x00,	// call register native

	0x68,0x00,0x00,0x00,0x00,	//next native
	0xBA,0x00,0x00,0x00,0x00,
	0xB9,0x00,0x00,0x00,0x00
};

unsigned char NativeRegMask[] =
{
	0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0x00,0x00,0x00,0x00,
	0xFF,0x00,0x00,0x00,0x00,

	0xFF,0x00,0x00,0x00,0x00,
	0xFF,0x00,0x00,0x00,0x00,
	0xFF,0x00,0x00,0x00,0x00,
};

unsigned char ExecuteFuncStrPattern[] =	"ExecuteFunc\0RemoveAllGuardPositions";
unsigned char CreateGroupStrPattern[] =	"CreateGroup\0()Hgroup;";
unsigned char DestroyGroupStrPattern[] = "DestroyGroup\0\0\0\0(Hgroup;)V";
unsigned char RemoveLocationStrPattern[] = "RemoveLocation\0\0(Hlocation;)V";
unsigned char JassPlayerStrPattern[] = "Player\0\0(I)Hplayer;";
unsigned char JassSetUnitAbilityLevelStrPattern[] = "SetUnitAbilityLevel\0(Hunit;II)I";

unsigned char LocationPatchPattern[] = {
	0x8B,0xC6,
	0x5E,
	0x8B,0xE5,
	0x5D,
	0xC3,
	0x90,0x90,

	0x55,	//next subroutine
	0x8B,0xEC,
	0x83,0xEC,0x08
};

unsigned char *LocationPatchMask = NULL;

unsigned char JassOpPatchPattern[] ={
	0x8B,0x7E,0x20,
	0x8D,0x4F,0x04,
	0x89,0x4E,0x20,
	0x8B,0x01,
	0x83,0xC1,0x04
};


unsigned char JassOpLimitPatchPattern[] = 
{
	0x8B, 0x4E, 0x44,
	0x40, 
	0x3B, 0xC1,
	0x89, 0x45, 0xF0, 
	0x0F, 0x8C, 0x00, 0x00, 0x00, 0x00,
	0xE8
};

unsigned char JassOpLimitPatchMask[] = 
{
	0xFF, 0xFF, 0xFF,
	0xFF,
	0xFF, 0xFF,
	0xFF, 0xFF, 0xFF,
	0xFF, 0xFF,	0x00, 0x00, 0x00, 0x00,
	0xFF
};

#define JassDivZeroPatchOffset 8
unsigned char JassDivZeroPatchPattern[] = 
{
	0xC2,0x10,0x00,
	0xE8,0x00,0x00,0x00,0x00,
	0x5F,
	0x5E,
	0xB8,0x07,0x00,0x00,0x00,
	0x5B,
	0x8B,0xE5,
	0x5D,
	0xC2,0x10,0x00
};

unsigned char JassDivZeroPatchMask[] = 
{
	0xFF,0xFF,0xFF,
	0xFF,0x00,0x00,0x00,0x00,
	0xFF,
	0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,
	0xFF,0xFF,
	0xFF,
	0xFF,0xFF,0xFF
};

#define JassVarUsePatchOffset 8
unsigned char JassVarUsePatchPattern[] = 
{
	0xC2,0x10,0x00,
	0xE8,0x00,0x00,0x00,0x00,
	0x5F,
	0x5E,
	0xB8,0x06,0x00,0x00,0x00,
	0x5B,
	0x8B,0xE5,
	0x5D,
	0xC2,0x10,0x00
};

unsigned char JassVarUsePatchMask[] = 
{
	0xFF,0xFF,0xFF,
	0xFF,0x00,0x00,0x00,0x00,
	0xFF,
	0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,
	0xFF,0xFF,
	0xFF,
	0xFF,0xFF,0xFF
};

unsigned char PausePatchPattern[] = 
{
	0x8B, 0x45, 0x08,
	0x33, 0xC9,
	0x85, 0xC0,
	0x74, 0x00,
	0xE8, 0x00, 0x00, 0x00, 0x00,
	0x3C, 0xFF
};

unsigned char PausePatchMask[] = 
{
	0xFF, 0xFF, 0xFF,
	0xFF, 0xFF,
	0xFF, 0xFF,
	0xFF, 0x00,
	0xFF, 0x00,0x00,0x00,0x00,
	0xFF, 0xFF
};
