/*
 * Logging daemon
 * popen() to use
 */

#include <stdio.h>
#include <stdlib.h>

#define SIZE 16384

int main(int argc, char **argv)
{
	int nlines = 1000;
	char *filename = "logd.txt";
	if(argc >= 2)
		filename = argv[1];
	if(argc >= 3)
		nlines = atoi(argv[2]);

	FILE *out = fopen(filename,"w");
	if(!out) {
		fprintf(stderr,"couldn't open output %s\n", filename);
		return 1;
	}

	char **buf = (char **)malloc(sizeof(char *)*nlines);
	for(int i=0;i<nlines;i++) buf[i] = (char *)malloc(sizeof(char)*SIZE);

	int i;
	for(i=0;fgets(buf[i],SIZE,stdin) > 0;i=(i+1)%nlines);

	int i0 = i;
	for(i=0;i<nlines;i++) {
		fputs(buf[(i+i0)%nlines],out);
	}
	fclose(out);
}
