#pragma once

void SaveConf();
void LoadConf();
void compilemap();

unsigned char SyntaxDisablePatch[] = {
	0x31,0xC0,	//xor eax,eax (return 0)
	0x90,
	0x90,0x90,0x90,
	0x90,0x90,0x90
};

unsigned char SyntaxDisablePattern[] = {
	0x50,
	0x8B,0xCF,
	0x89,0x5F,0x04,
	0xFF,0x52,0x0C,
	0x5F,
	0x5E,
	0x5B
};

unsigned char SyntaxDisableMask[] = {
	0xFF,
	0xFF,0xFF,
	0xFF,0xFF,0xFF,
	0xFF,0xFF,0xFF,
	0xFF,
	0xFF,
	0xFF
};

unsigned char AutoDisablePattern[] = {
	0xE8,0x00,0x00,0x00,0x00,
	0x85,0xC0,
	0x75,0x09,
	0x8B,0x4D,0xFC,
	0x53,
	0xE8
};

unsigned char AutoDisableMask[] = {
	0xFF,0x00,0x00,0x00,0x00,
	0xFF,0xFF,
	0xFF,0xFF,
	0xFF,0xFF,0xFF,
	0xFF,
	0xFF
};

unsigned char AutoDisablePatch[] = {
	0x90,0x90,0x90,0x90,0x90
};

unsigned char DescriptionPopupPattern[] = {
	0x74,0x4C,
	0x57,
	0x68,0x00,0x00,0x00,0x00,
	0x8D,0x95,0x00,0x00,0x00,0x00,
	0xB9,0x00,0x00,0x00,0x00,
	0xE8
};

unsigned char DescriptionPopupMask[] = {
	0xFF,0xFF,
	0xFF,
	0xFF,0x00,0x00,0x00,0x00,
	0xFF,0xFF,0x00,0x00,0x00,0x00,
	0xFF,0x00,0x00,0x00,0x00,
	0xFF
};

unsigned char DescriptionPopupPatch[] = {
	0xEB	//j(n)z -> jmp
};

unsigned char AlwaysEnablePattern[] = {
	0x75,0x08,
	0x5F,
	0x5E,
	0x8B,0xE5,
	0x5D,
	0xC2,0x0C,0x00,
	0x68
};

unsigned char AlwaysEnableMask[] = {
	0xFF,0xFF,
	0xFF,
	0xFF,
	0xFF,0xFF,
	0xFF,
	0xFF,0xFF,0xFF,
	0xFF
};

unsigned char AlwaysEnablePatch[] = {
	0xEB
};

int AlwaysEnableOffset2 = 3;

unsigned char AlwaysEnablePattern2[] = {
	0x8B,0x4E,0x48,
	0x56,
	0xE8,0x00,0x00,0x00,0x00,
	0x85,0xC0,
	0x75,0x08,
	0x5F,
	0x5E,
	0x8B,0xE5
};

unsigned char AlwaysEnableMask2[] = {
	0xFF,0xFF,0xFF,
	0xFF,
	0xFF,0x00,0x00,0x00,0x00,
	0xFF,0xFF,
	0xFF,0xFF,
	0xFF,
	0xFF,
	0xFF,0xFF
};

/*
 * 1.20e:  0x5C88F7
 */
unsigned char AlwaysEnablePatch2[] = {
	0x90,
	0x90,0x90,0x90,0x90,0x90,	// remove push && call
	0x90,0x90,
	0xEB				//jnz -> jmp
};

unsigned char ImpPrefixPattern[] =	"war3mapImported\\";
unsigned char ImpPrefixMask[] =	{
	0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF
};
unsigned char ImpPrefixPatch[] = { 0x00 };

unsigned char DoodadLimitPattern[] = {
	0x7E,0x5C,
	0x53,
	0x57,
	0x33,0xFF,
	0x8B,0x00,
	0x8B,0x46,0x00,
	0x8B,0x8C,0x00,0x00,0x00,0x00,0x00,
	0x03,0xC7
};

unsigned char DoodadLimitMask[] = {
	0xFF,0xFF,
	0xFF,
	0xFF,
	0xFF,0xFF,
	0xFF,0x00,
	0xFF,0xFF,0x00,
	0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF
};

unsigned char DoodadLimitPatch[] = {
	0xEB
};

unsigned char UnitItemLimitPattern[] = {
	0x0F,0x8E,0x00,0x00,0x00,0x00,
	0x89,0x00,0x00,
	0x89,0x00,0x00,
	0x8B,0x43,0x00,
	0x8B,0x8C,0x00,0x00,0x00,0x00,0x00,
	0x03,0xC7,
	0xF6,0xC5,0x04

};

unsigned char UnitItemLimitMask[] = {
	0xFF,0xFF,0x00,0xFF,0xFF,0xFF,
	0xFF,0x00,0x00,
	0xFF,0x00,0x00,
	0xFF,0xFF,0x00,
	0xFF,0xFF,0x00,0x00,0x00,0x00,0x00,
	0xFF,0xFF,
	0xFF,0xFF,0xFF
};

unsigned char UnitItemLimitPatch[] = {
	0xE9,0xA0,0x00,0x00,0x00,0x90
};

unsigned char MapSizeLimitPattern[] = {
	0x7E,0x59,
	0x8B,0x4E,0x04,
	0x6A,0x02,
	0xE8,0x00,0x00,0x00,0x00,
	0x6A,0x00,
	0x68,0x04,0x01,0x00,0x00,
	0x8D,0x95
};

unsigned char MapSizeLimitMask[] = {
	0xFF,0xFF,
	0xFF,0xFF,0xFF,
	0xFF,0xFF,
	0xFF,0x00,0x00,0x00,0x00,
	0xFF,0xFF,
	0xFF,0xFF,0xFF,0xFF,0xFF,
	0xFF,0xFF
};

unsigned char MapSizeLimitPatch[] = {
	0xEB
};
